/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servlet;

import bdd.VentilMysql;
import bean.Pompier;
import bean.Ventil;
import com.mysql.cj.util.StringUtils;
import form.VentilForm;
import java.io.IOException;
import java.io.PrintWriter;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.Calendar;
import util.TrmtDate;

/**
 *
 * @author thomas.millot
 */
public class MesDispoServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try ( PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet MesDispoServlet</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet MesDispoServlet at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
                //Méthode accédée uniquement depuis la barre du menu
        System.out.println("doGet mesDispo");
        int pageDemandee = 0;
        int page = 6;
        String jsp = "mesDispoJSP.jsp";

        boolean erreur = false;
        if (request.getParameter("pageDemandee") != null) {
            String pageEnString = request.getParameter("pageDemandee");
            boolean isNumeric = StringUtils.isStrictlyNumeric(pageEnString);
            if (isNumeric) {
                pageDemandee = Integer.parseInt(pageEnString);
                if (pageDemandee != 6) { // erreur
                    erreur = true;
                }
            } else {
                erreur = true;
            }
        } else {
            erreur = true;
        }

        HttpSession maSession = request.getSession();
        Pompier lePompier = null;
        
        if (maSession.getAttribute("lesVentilInit") == null) {

            /* Initialisations des dates de la semaine */
            Calendar[] lesDates = new Calendar[7];
            String[] lesDatesEnString = new String[7];
            lesDates[0] = TrmtDate.getDateDebutSemaine();
            lesDatesEnString[0] = TrmtDate.getDateAAfficher(lesDates[0]);
            for (int i = 1; i < lesDates.length; i++) {
                lesDates[i] = TrmtDate.addDays(lesDates[0], i);
                lesDatesEnString[i] = TrmtDate.getDateAAfficher(lesDates[i]);
            }
           
            maSession.setAttribute("lesDates", lesDates);
            maSession.setAttribute("lesDatesEnString", lesDatesEnString);
            //System.out.println("lesDates "+ lesDates[4].getTime());

            /* Initialisation des périodes */
            String[] lesPeriodes = {"1", "2", "3", "4"};
            maSession.setAttribute("lesPeriodes", lesPeriodes);

            /* Recherche des ventilations */
            VentilMysql vm = new VentilMysql();
            ArrayList<Ventil> lesVentilInit = vm.getLesVentil(lesDates, lesPeriodes, request);
            //System.out.println("lesVentilInit : " + lesVentilInit);
            maSession.setAttribute("lesVentilInit", lesVentilInit);

            /* Initialisation des couleurs */
            String[] lesCouleurs = {"vert", "orange", "rouge"};
            maSession.setAttribute("lesCouleurs", lesCouleurs);
        }
        
        if (erreur == false) {
            lePompier = (Pompier) maSession.getAttribute("lePompierConnecte");
            if (pageDemandee == 6 && lePompier.getLeStatut().getCode() != 1) { // erreur
                erreur = true;
            }
        }
                System.out.println("erreur : "+ erreur);
        if (erreur) {
            request.getRequestDispatcher("/authentification").forward(request, response); // redirection servlet
        } else {
            request.setAttribute("page", page);
            maSession.setAttribute("lePompier", lePompier);
            getServletContext().getRequestDispatcher("/WEB-INF/" + jsp).forward(request, response);            
        }
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
         //processRequest(request, response);
        //a.créer un objet de type ventilForm
        VentilForm vf = new VentilForm();

        //b.Appeler verifVentil
        vf.verifVentil(request);

        //c.Afficher le menu
        getServletContext().getRequestDispatcher("/WEB-INF/pompierJSP.jsp").forward(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
